
#include "McrSerialInterface.h"
#include "stdafx.h"
#include "McrSerialEnumDevices.h" // for the serial port
#include "SoftwareConfig.h"
#include "DebugOutput.h"
#include "Serial.h"


int          iNumberPericomPortsFound;
CEnumDevInfo cPrimaryPericomPortFound[MAX_PERICOM_PORTS_FOUND];

//void CALLBACK EnumCallbackWrapper(const CEnumDevInfo* pInfo, BOOL bIsPhysical);
void __stdcall EnumCallbackWrapper(const CEnumDevInfo* pInfo, BOOL bIsPhysical);

CMcrSerialInterface::CMcrSerialInterface()
{
	int ii;

	m_bNoneItem = TRUE;								// First item is "<None>"
	m_bOnlyPhysical = FALSE;						// Include virtual COM ports
	m_bOnlyPresent = TRUE;							// Only present ports
	wcscpy_s(m_strNone, sizeof(m_strNone)/sizeof(TCHAR), _T("<None>"));

	iNumberPericomPortsFound = 0;
	for (ii=0; ii<MAX_PERICOM_PORTS_FOUND; ii++)
	{
		cPrimaryPericomPortFound[ii].m_nPortNum = 0;
	}
}


CMcrSerialInterface::~CMcrSerialInterface()
{

}



void CMcrSerialInterface::EnumAllDevices(void)
{
	// The EnumCallbackWrapper will save the Pericom COM ports it finds in the cPrimaryPericomPortFound array.
	CEnumDevices Enum;
	BOOL bResult = Enum.EnumSerialPorts(EnumCallbackWrapper, m_bOnlyPresent, m_bOnlyPhysical);
}

// Remember the pericom ports found
void __stdcall EnumCallbackWrapper(const CEnumDevInfo* pInfo, BOOL bIsPhysical)
{
	//ASSERT(pObject != NULL);

	//TCHAR csPortName[512];
	int iFound;
	const wchar_t *ptcFound;




	if (pInfo == NULL)
	{
		#ifdef _DEBUG_ERROR
		TCHAR tcDebugBuff[256];
		swprintf_s(tcDebugBuff,sizeof(tcDebugBuff)/sizeof(TCHAR),_T("!!!CMcrSerialInterface::EnumCallbackWrapper null pInfo"));
		cDebugOutput->DebugMsg(tcDebugBuff);
		#endif

		return;
	}

	if (pInfo->m_nPortNum > 0)
	{
		if (!bIsPhysical || !(pInfo->m_nPortNum & DATA_VIRTUAL_MASK))
		{
			ptcFound = wcsstr(pInfo->m_strName, _T("Pericom Serial Port Device"));
			if (ptcFound)
			{
				iFound = true;
				if (cPrimaryPericomPortFound[iNumberPericomPortsFound].m_nPortNum & DATA_PORT_MASK)
				{
					if ((cPrimaryPericomPortFound[iNumberPericomPortsFound].m_nPortNum & DATA_PORT_MASK) < (pInfo->m_nPortNum & DATA_PORT_MASK))
					{
						// Keep a copy of each Pericom port. We may need some of the parameters later.
						cPrimaryPericomPortFound[iNumberPericomPortsFound] = *pInfo;
					}
				} else
				{
					// Keep a copy of each Pericom port. We may need some of the parameters later.
					cPrimaryPericomPortFound[iNumberPericomPortsFound] = *pInfo;
				}

				// don't go beyond the max. number of pericom devices we can save
				// We should never reach the max. of 30 pericom devices!!!
				if (iNumberPericomPortsFound < (MAX_PERICOM_PORTS_FOUND-1))
				{
					iNumberPericomPortsFound++; // Point to the next location to save pericom data
				}
			} else
			{
				iFound = false;
			}

			//if ((pInfo->m_nPortNum & DATA_PORT_MASK) == m_nDefPort)
			//	SetCurSel(nItem);
		}
	}
}



//void CMcrSerialInterface::AddItem(const CEnumDevInfo* pInfo)
//{
//	//TCHAR csPortName[512];
//	int iFound;
//	const wchar_t *ptcFound;
//
//	#ifdef _DEBUG_ERROR
//	if (pInfo == NULL)
//	{
//		TCHAR tcDebugBuff[256];
//		swprintf_s(tcDebugBuff,sizeof(tcDebugBuff)/sizeof(TCHAR),_T("!!!CMcrSerialInterface::AddItem null pInfo"));
//		cDebugOutput->DebugMsg(tcDebugBuff);
//	}
//	#endif
//
//	if (pInfo->m_nPortNum > 0)
//	{
//		if ((!m_bOnlyPhysical) || !(pInfo->m_nPortNum & DATA_VIRTUAL_MASK))
//		{
//			//csPortName = pInfo->m_strName.GetString();
//
//			//iFound = csPortName.Find(_T("Pericom"));
//			ptcFound = wcsstr(pInfo->m_strName, _T("Pericom"));
//			if (ptcFound)
//				iFound = true;
//			else
//				iFound = false;
//
//			//if ((pInfo->m_nPortNum & DATA_PORT_MASK) == m_nDefPort)
//			//	SetCurSel(nItem);
//		}
//	}
//}








