#ifndef _REGCLASS_H
#define _REGCLASS_H

#include <windef.h>

// registration resource stamps

#define STAMP_REGISTERED	0x7a22f1c8	// target is registered
#define STAMP_UNREGISTERED	0x16b42502	// target is not yet registered

// registartion resource statuses

#define REGIS_NO			1			// not yet registered
#define REGIS_YES			2			// registered
#define REGIS_CORRUPT		3			// registration is corrupt/tampered with
#define REGIS_LOADERR		5			// failure loading registration binary

// encryption keys

#define CRYPT_KEY1			"KRALC"
#define CRYPT_KEY2			"NOSNITS"

// defined sizes for fields in registration resource

#define USER_SIZE			100			
#define ORG_SIZE			100


#pragma pack(push,8)

typedef struct _CLARKREGINFO
{
	ULONG	dummy1;
	ULONG	dummy2;
	ULONG	isregistered;				
	ULONG	checksum;					
	char	user[USER_SIZE];			
	char	org[ORG_SIZE];		
	char	originUser[USER_SIZE];
	char	originOrg[ORG_SIZE];

} CLARKREGINFO;

#pragma pack(pop)

class CClarkReg
{
	public:
		CClarkReg();

		WORD CClarkReg::OpenRegFile(char *fspec);
		BOOL WriteRegistration(char *fspec, char *user, char *org);
		void CryptString(char *s, WORD size);
		void ChecksumString(char *s, DWORD *checksum, WORD size);

		// installer's name/org 

		char user[USER_SIZE];
		char org[ORG_SIZE];

		// OS registration info for computer on which registration was performed

		char originUser[USER_SIZE];
		char originOrg[ORG_SIZE];

	private:
		CLARKREGINFO	regInfo;
		HMODULE			moduleHandle;
		HRSRC			h_RegRes;
		HGLOBAL			g_RegRes;
		HINSTANCE		h_Instance;
		HANDLE			h_Update;
		char			targetExe[MAX_PATH];
		char			*key1;
		char			*key2;

};

#endif // _REGCLASS_H
